# Generated by go2rpm
%bcond_without check
%bcond_without bootstrap

# https://github.com/docker/cli
%global goipath         github.com/docker/cli
Version:                18.09.6

%gometa

%global goipaths0       github.com/docker/cli
%global goipathsex0     github.com/docker/cli/cli/command/image

%if %{without bootstrap}
%global goipaths1       github.com/docker/cli/cli/command/image
%endif

%global common_description %{expand:
This repository is the home of the cli used in the Docker CE and Docker EE
products.}

%global golicenses      LICENSE NOTICE
%global godocs          docs CONTRIBUTING.md README.md TESTING.md AUTHORS\\\
                        examples docs

Name:           %{goname}
Release:        1%{?dist}
Summary:        The docker CLI

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}
# clientOpts was changed in github.com/docker/docker tip
Patch0:         0001-Fix-clientOpts-definition.patch
# SummarizeLicense now takes one argument instead of two
Patch1:         0001-Fix-call-to-SummarizeLicense.patch
# swarm.CredentialSpec from github.com/docker/docker/api/types/swarm has a new format
Patch2:         0001-Fix-for-new-docker.patch
# IsFormat(string) changed to IsFormat(interface {}) in github.com/xeipuuv/gojsonschema
Patch3:         0001-Fix-for-new-gojsonschema.patch
# New methods in github.com/containerd/containerd
Patch4:         0001-Fix-for-new-containerd.patch

BuildRequires:  golang(github.com/containerd/console)
BuildRequires:  golang(github.com/containerd/containerd)
BuildRequires:  golang(github.com/containerd/containerd/containers)
BuildRequires:  golang(github.com/containerd/containerd/content)
BuildRequires:  golang(github.com/containerd/containerd/diff/apply)
BuildRequires:  golang(github.com/containerd/containerd/errdefs)
BuildRequires:  golang(github.com/containerd/containerd/images)
BuildRequires:  golang(github.com/containerd/containerd/mount)
BuildRequires:  golang(github.com/containerd/containerd/namespaces)
BuildRequires:  golang(github.com/containerd/containerd/oci)
BuildRequires:  golang(github.com/containerd/containerd/remotes)
BuildRequires:  golang(github.com/containerd/containerd/remotes/docker)
BuildRequires:  golang(github.com/containerd/containerd/rootfs)
BuildRequires:  golang(github.com/containerd/containerd/snapshots)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/clientset)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/clientset/scheme)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/clientset/typed/compose/v1alpha3)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/clientset/typed/compose/v1beta1)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/clientset/typed/compose/v1beta2)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/informers)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/informers/compose)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/informers/compose/v1beta2)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/informers/internalinterfaces)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/client/listers/compose/v1beta2)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/compose/clone)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/compose/impersonation)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/compose/v1alpha3)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/compose/v1beta1)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/compose/v1beta2)
BuildRequires:  golang(github.com/docker/compose-on-kubernetes/api/labels)
BuildRequires:  golang(github.com/docker/distribution)
BuildRequires:  golang(github.com/docker/distribution/manifest/manifestlist)
BuildRequires:  golang(github.com/docker/distribution/manifest/schema2)
BuildRequires:  golang(github.com/docker/distribution/reference)
BuildRequires:  golang(github.com/docker/distribution/registry/api/errcode)
BuildRequires:  golang(github.com/docker/distribution/registry/api/v2)
BuildRequires:  golang(github.com/docker/distribution/registry/client)
BuildRequires:  golang(github.com/docker/distribution/registry/client/auth)
BuildRequires:  golang(github.com/docker/distribution/registry/client/auth/challenge)
BuildRequires:  golang(github.com/docker/distribution/registry/client/transport)
BuildRequires:  golang(github.com/docker/docker-credential-helpers/client)
BuildRequires:  golang(github.com/docker/docker-credential-helpers/credentials)
BuildRequires:  golang(github.com/docker/docker/api)
BuildRequires:  golang(github.com/docker/docker/api/types)
BuildRequires:  golang(github.com/docker/docker/api/types/blkiodev)
BuildRequires:  golang(github.com/docker/docker/api/types/container)
BuildRequires:  golang(github.com/docker/docker/api/types/events)
BuildRequires:  golang(github.com/docker/docker/api/types/filters)
BuildRequires:  golang(github.com/docker/docker/api/types/image)
BuildRequires:  golang(github.com/docker/docker/api/types/mount)
BuildRequires:  golang(github.com/docker/docker/api/types/network)
BuildRequires:  golang(github.com/docker/docker/api/types/registry)
BuildRequires:  golang(github.com/docker/docker/api/types/strslice)
BuildRequires:  golang(github.com/docker/docker/api/types/swarm)
BuildRequires:  golang(github.com/docker/docker/api/types/versions)
BuildRequires:  golang(github.com/docker/docker/api/types/volume)
BuildRequires:  golang(github.com/docker/docker/builder/dockerignore)
BuildRequires:  golang(github.com/docker/docker/builder/remotecontext/git)
BuildRequires:  golang(github.com/docker/docker/client)
BuildRequires:  golang(github.com/docker/docker/errdefs)
BuildRequires:  golang(github.com/docker/docker/pkg/archive)
BuildRequires:  golang(github.com/docker/docker/pkg/fileutils)
BuildRequires:  golang(github.com/docker/docker/pkg/homedir)
BuildRequires:  golang(github.com/docker/docker/pkg/idtools)
BuildRequires:  golang(github.com/docker/docker/pkg/ioutils)
BuildRequires:  golang(github.com/docker/docker/pkg/jsonmessage)
BuildRequires:  golang(github.com/docker/docker/pkg/pools)
BuildRequires:  golang(github.com/docker/docker/pkg/progress)
BuildRequires:  golang(github.com/docker/docker/pkg/signal)
BuildRequires:  golang(github.com/docker/docker/pkg/stdcopy)
BuildRequires:  golang(github.com/docker/docker/pkg/streamformatter)
BuildRequires:  golang(github.com/docker/docker/pkg/stringid)
BuildRequires:  golang(github.com/docker/docker/pkg/system)
BuildRequires:  golang(github.com/docker/docker/pkg/term)
BuildRequires:  golang(github.com/docker/docker/pkg/urlutil)
BuildRequires:  golang(github.com/docker/docker/registry)
BuildRequires:  golang(github.com/docker/go-connections/nat)
BuildRequires:  golang(github.com/docker/go-connections/tlsconfig)
BuildRequires:  golang(github.com/docker/go-units)
BuildRequires:  golang(github.com/docker/licensing)
BuildRequires:  golang(github.com/docker/licensing/model)
BuildRequires:  golang(github.com/docker/swarmkit/api)
BuildRequires:  golang(github.com/docker/swarmkit/api/defaults)
BuildRequires:  golang(github.com/docker/swarmkit/api/genericresource)
BuildRequires:  golang(github.com/gogo/protobuf/types)
BuildRequires:  golang(github.com/google/shlex)
BuildRequires:  golang(github.com/hashicorp/go-version)
BuildRequires:  golang(github.com/imdario/mergo)
BuildRequires:  golang(github.com/mattn/go-shellwords)
BuildRequires:  golang(github.com/mitchellh/mapstructure)
BuildRequires:  golang(github.com/moby/buildkit/api/services/control)
BuildRequires:  golang(github.com/moby/buildkit/client)
BuildRequires:  golang(github.com/moby/buildkit/session)
%if %{without bootstrap}
BuildRequires:  golang(github.com/moby/buildkit/session/auth/authprovider)
%endif
BuildRequires:  golang(github.com/moby/buildkit/session/filesync)
BuildRequires:  golang(github.com/moby/buildkit/session/secrets/secretsprovider)
BuildRequires:  golang(github.com/moby/buildkit/session/sshforward/sshprovider)
BuildRequires:  golang(github.com/moby/buildkit/util/appcontext)
BuildRequires:  golang(github.com/moby/buildkit/util/progress/progressui)
BuildRequires:  golang(github.com/morikuni/aec)
BuildRequires:  golang(github.com/opencontainers/go-digest)
BuildRequires:  golang(github.com/opencontainers/image-spec/identity)
BuildRequires:  golang(github.com/opencontainers/image-spec/specs-go/v1)
BuildRequires:  golang(github.com/opencontainers/runtime-spec/specs-go)
BuildRequires:  golang(github.com/pkg/errors)
BuildRequires:  golang(github.com/sirupsen/logrus)
BuildRequires:  golang(github.com/spf13/cobra)
BuildRequires:  golang(github.com/spf13/cobra/doc)
BuildRequires:  golang(github.com/spf13/pflag)
BuildRequires:  golang(github.com/theupdateframework/notary)
BuildRequires:  golang(github.com/theupdateframework/notary/client)
BuildRequires:  golang(github.com/theupdateframework/notary/client/changelist)
BuildRequires:  golang(github.com/theupdateframework/notary/cryptoservice)
BuildRequires:  golang(github.com/theupdateframework/notary/passphrase)
BuildRequires:  golang(github.com/theupdateframework/notary/storage)
BuildRequires:  golang(github.com/theupdateframework/notary/trustmanager)
BuildRequires:  golang(github.com/theupdateframework/notary/trustpinning)
BuildRequires:  golang(github.com/theupdateframework/notary/tuf/data)
BuildRequires:  golang(github.com/theupdateframework/notary/tuf/signed)
BuildRequires:  golang(github.com/theupdateframework/notary/tuf/utils)
BuildRequires:  golang(github.com/tonistiigi/fsutil/types)
BuildRequires:  golang(github.com/xeipuuv/gojsonschema)
BuildRequires:  golang(golang.org/x/crypto/ssh/terminal)
BuildRequires:  golang(golang.org/x/sync/errgroup)
BuildRequires:  golang(golang.org/x/sys/unix)
BuildRequires:  golang(golang.org/x/text/width)
BuildRequires:  golang(golang.org/x/time/rate)
BuildRequires:  golang(gopkg.in/yaml.v2)
BuildRequires:  golang(gotest.tools/assert)
BuildRequires:  golang(gotest.tools/assert/cmp)
BuildRequires:  golang(gotest.tools/fs)
BuildRequires:  golang(gotest.tools/icmd)
BuildRequires:  golang(gotest.tools/poll)
BuildRequires:  golang(gotest.tools/skip)
BuildRequires:  golang(k8s.io/api/apps/v1beta2)
BuildRequires:  golang(k8s.io/api/core/v1)
BuildRequires:  golang(k8s.io/apimachinery/pkg/api/errors)
BuildRequires:  golang(k8s.io/apimachinery/pkg/apis/meta/v1)
BuildRequires:  golang(k8s.io/apimachinery/pkg/fields)
BuildRequires:  golang(k8s.io/apimachinery/pkg/runtime)
BuildRequires:  golang(k8s.io/apimachinery/pkg/runtime/schema)
BuildRequires:  golang(k8s.io/apimachinery/pkg/util/runtime)
BuildRequires:  golang(k8s.io/apimachinery/pkg/watch)
BuildRequires:  golang(k8s.io/client-go/discovery)
BuildRequires:  golang(k8s.io/client-go/kubernetes)
BuildRequires:  golang(k8s.io/client-go/kubernetes/typed/apps/v1beta2)
BuildRequires:  golang(k8s.io/client-go/kubernetes/typed/core/v1)
BuildRequires:  golang(k8s.io/client-go/rest)
BuildRequires:  golang(k8s.io/client-go/tools/cache)
BuildRequires:  golang(k8s.io/client-go/tools/clientcmd)
BuildRequires:  golang(k8s.io/client-go/tools/clientcmd/api)
BuildRequires:  golang(k8s.io/kubernetes/pkg/api/v1/pod)
BuildRequires:  golang(vbom.ml/util/sortorder)

%if %{with check}
# Tests
BuildRequires:  golang(github.com/containerd/containerd/cio)
BuildRequires:  golang(github.com/google/go-cmp/cmp)
BuildRequires:  golang(github.com/google/go-cmp/cmp/cmpopts)
BuildRequires:  golang(gotest.tools/env)
BuildRequires:  golang(gotest.tools/golden)
BuildRequires:  golang(k8s.io/apimachinery/pkg/labels)
BuildRequires:  golang(k8s.io/apimachinery/pkg/runtime/serializer)
BuildRequires:  golang(k8s.io/apimachinery/pkg/types)
BuildRequires:  golang(k8s.io/apimachinery/pkg/util/intstr)
BuildRequires:  golang(k8s.io/client-go/kubernetes/fake)
BuildRequires:  golang(k8s.io/client-go/testing)
%endif

%description
%{common_description}

%gopkg

%prep
%goprep
%autopatch -p1
find . -name "*.go" -exec sed -i "s|github.com/flynn-archive/go-shlex|github.com/google/shlex|" "{}" +;

# %%build
# for cmd in cmd/* ; do
#   %%gobuild -o %%{gobuilddir}/bin/$(basename $cmd) %%{goipath}/$cmd
# done

%install
%gopkginstall
# install -m 0755 -vd                     %%{buildroot}%%{_bindir}
# install -m 0755 -vp %%{gobuilddir}/bin/* %%{buildroot}%%{_bindir}/

%%if %{with check}
%check
%if %{with bootstrap}
%gocheck -t cmd \
         -d cli/command/image \
         -d cli/command/container \
         -d cli/command/engine \
         -d cli/command/formatter \
         -d cli/command/node \
         -d cli/command/plugin \
         -d cli/command/registry \
         -d cli/command/stack \
         -d cli/command/system \
         -d cli/command/trust
%else
%gocheck -t cmd \
         -d cli/command/formatter \
         -d cli/command/node \
         -d cli/command/registry \
         -d cli/command/stack
%endif
%endif

# %%files
# %%license LICENSE NOTICE
# %%doc docs CONTRIBUTING.md README.md TESTING.md AUTHORS examples docs
# %%{_bindir}/*

%gopkgfiles

%changelog
* Wed May 01 15:26:24 CEST 2019 Robert-André Mauchin <zebob.m@gmail.com> - 18.09.6-1
- Initial package
